HDU5124:lines(线段树+离散化)或(离散化思想)

http://acm.hdu.edu.cn/showproblem.php?pid=5124

Problem Description

John has several lines. The lines are covered on the X axis. Let A is a point which is covered by the most lines. John wants to know how many lines cover A.

Input

The first line contains a single integer T(1≤T≤100)(the data for N>100 less than 11 cases),indicating the number of test cases.
Each test case begins with an integer N(1≤N≤105),indicating the number of lines.
Next N lines contains two integers Xi and Yi(1≤Xi≤Yi≤109),describing a line.

Output

For each case, output an integer means how many lines cover A.

Sample Input

2

5

1 2

2 2

2 4

3 4

5 1000

5

11

2 2

3 3

4 4

5 5

Sample Output

3

1

题目解析:

题意:给定 n 个区间,问最多重复的子区间?

题解:(离散化思想)讲所有的数都排个序,将区间的左值定为 1 ,右值定为 -1 ,这样对所有的数搜一遍过去找最大的值即可;或者用线段树+离散化。

一:线段树

#include <iostream>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <algorithm>
#define N 100010
using namespace std;
struct  li
{
    int x,y;
}line[N];
struct node
{
    int l,r;
    int lz;
}q[8*N];
int n,tt,X[2*N];
int maxx;
void build(int l,int r,int rt)
{
    q[rt].l=l;
    q[rt].r=r;
    q[rt].lz=0;
    if(l==r)
        return ;
    int mid=(l+r)>>1;
    build(l,mid,rt<<1);
    build(mid+1,r,rt<<1|1);
    return ;
}
void pushdown(int rt)
{
    if(q[rt].lz)
    {
        q[rt<<1].lz+=q[rt].lz;
        q[rt<<1|1].lz+=q[rt].lz;
        q[rt].lz=0;
    }
}
void update(int lf,int rf,int l,int r,int rt)
{
    if(lf<=l&&rf>=r)
    {
        q[rt].lz+=1;
        return ;
    }
    pushdown(rt);
    int mid=(l+r)>>1;
    if(lf<=mid) update(lf,rf,l,mid,rt<<1);
    if(rf>mid) update(lf,rf,mid+1,r,rt<<1|1);
    return ;
}
void query(int l,int r,int rt)
{

    if(l==r)
    {
       maxx=max(maxx,q[rt].lz);
       return ;
    }
    pushdown(rt);
    int mid=(l+r)>>1;
    query(l,mid,rt<<1);
    query(mid+1,r,rt<<1|1);
    return ;
}
int main()
{
    int T;
    scanf("%d",&T);
    while(T--)
    {
        tt=0;
        maxx=-1;
        scanf("%d",&n);
        for(int i=0;i<n;i++)
        {
            scanf("%d%d",&line[i].x,&line[i].y);
            X[tt++]=line[i].x;
            X[tt++]=line[i].y;
        }
        sort(X,X+tt);
        int sum=unique(X,X+tt)-X;
        build(1,sum,1);
        for(int i=0;i<n;i++)
        {
            int le=lower_bound(X,X+sum,line[i].x)-X+1;
            int re=lower_bound(X,X+sum,line[i].y)-X+1;
            if(le<=re)  update(le,re,1,sum,1);
        }
        query(1,sum,1);
        printf("%d\n",maxx);
    }
    return 0;
}

二:离散化:思路:可以把一条线段分出两个端点离散化,左端点被标记为-1,右端点被标记为1,然后排序,如果遇到标记为-1,cnt++,否则cnt--;找出cnt的最大值。

#include <cstdio>
#include <cstring>
#include <algorithm>
#define maxn 200010
using namespace std;

struct node
{
    int x,c;
    bool operator<(const node &a)const
    {
        return (x<a.x)||(x==a.x&&c<a.c);
    }
}p[maxn];

int t;
int n;

int main()
{
    scanf("%d",&t);
    while(t--)
    {
        scanf("%d",&n);
        for(int i=0; i<n; i++)
        {
            int s,e;
            scanf("%d%d",&s,&e);
            p[i*2].x=s;
            p[i*2].c=-1;
            p[i*2+1].x=e;
            p[i*2+1].c=1;
        }
        sort(p,p+2*n);
        int cnt=0; int ans=0;
        for(int i=0; i<2*n; i++)
        {
            if(p[i].c==-1)
            {
                cnt++;
            }
            else
                cnt--;
            ans=max(ans,cnt);
        }
        printf("%d\n",ans);
    }
    return 0;
}

可惜做BC时,这两种方法都没想出来,悲催!

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>
#include <ctype.h>
#include <string>
#include <queue>
#include <set>
#include <map>
#include <stack>
#include <vector>
#include <algorithm>
#include <iostream>
#define PI acos( -1.0 )
using namespace std;
typedef long long ll;

const int NO = 1e5 + 10;
struct ND
{
    int x, y;
}st[NO<<1];
int n;

bool cmp( const ND &a, const ND &b )
{
    if( a.x == b.x ) return a.y > b.y;
    return a.x < b.x;
}

int main()
{
    int T;
    scanf( "%d",&T );
    while( T-- )
    {
        scanf( "%d", &n );
        int cur = 0;
        for( int i = 0; i < n; ++i )
        {
            scanf( "%d", &st[cur].x );
            st[cur++].y = 1;
            scanf( "%d", &st[cur].x );
            st[cur++].y = -1;
        }
        sort( st, st+cur, cmp );
        int ans = 0;
        int Max = 0;
        for( int i = 0; i < cur; ++i )
        {
            ans += st[i].y;
            Max = max( ans, Max );
        }
        printf( "%d\n", Max );
    }
    return 0;
}

时间: 2024-10-08 19:39:43

HDU5124:lines(线段树+离散化)或(离散化思想)的相关文章

POJ 2528 Mayor&#39;s posters(线段树区间染色+离散化或倒序更新)

Mayor's posters Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 59239   Accepted: 17157 Description The citizens of Bytetown, AB, could not stand that the candidates in the mayoral election campaign have been placing their electoral post

POJ1151 Atlantis 【扫描线】+【线段树】+【离散化】

Atlantis Time Limit: 1000MS   Memory Limit: 10000K Total Submissions: 16882   Accepted: 6435 Description There are several ancient Greek texts that contain descriptions of the fabled island Atlantis. Some of these texts even include maps of parts of

POJ 2528 Mayor&#39;s posters (线段树区间更新+离散化)

题目链接:http://poj.org/problem?id=2528 给你n块木板,每块木板有起始和终点,按顺序放置,问最终能看到几块木板. 很明显的线段树区间更新问题,每次放置木板就更新区间里的值.由于l和r范围比较大,内存就不够了,所以就用离散化的技巧 比如将1 4化为1 2,范围缩小,但是不影响答案. 写了这题之后对区间更新的理解有点加深了,重点在覆盖的理解(更新左右两个孩子节点,然后值清空),还是要多做做题目. 1 #include <iostream> 2 #include <

POJ2528 Mayor&#39;s posters(线段树染色问题+离散化)

题目大意:有t组数据,每组数据给你n张海报(1<=n<=10000),下面n组数据分别给出每张海报的左右范围(1 <= l <= r <= 10000000),下一张海报会覆盖前一张海报,求最后可见(包括完全和不完全可见)的海报有几张. 例如: 1 5 1 4 2 6 8 10 3 4 7 10 如上图所示,答案为4. 解题思路:其实这是一道区间染色问题,但是由于查找区间太大,显然直接建树会导致MLE,所以这里通过使用对区间的离散化来缩小查找范围.参考了一些大牛博客,简单说一

线段树区间更新+离散化——ZOJ 3299

对应ZOJ题目:点击打开链接 Fall the Brick Time Limit: 3000MS   Memory Limit: 32768KB   64bit IO Format: %lld & %llu Submit Status Description Now the God is very angry, so he wants to punish the lazy, greedy humans. He chooses to throw some lines of bricks (just

hdu1542线段树(扫描线+离散化)

题目链接 要求矩形的面积并 代码不复杂,主要要理解扫描线的思想以及一些细节的处理. 首先需要将接收到的x坐标离散化,方法就是排序去重.接下来的线段树建立在这个 关于x坐标的数组上,这很关键.线段树的节点代表一段区间,这个区间是由x坐标数组的下标 来构成的.更新的时候就根据水平线段的左右x坐标获得区间,然后更新区间. 看了这么多,离散化之后关于r+1,r-1的问题还是很模糊. 我尽力理解一下,有一个[0,4]的区间,叶节点分别为[0,0],[1,1],[2,2],[3,3],[4,4], 那么[0

LightOJ 1089 - Points in Segments (II) 线段树区间修改+离散化

http://www.lightoj.com/volume_showproblem.php?problem=1089 题意:给出许多区间,查询某个点所在的区间个数 思路:线段树,由于给出的是区间,查询的是点,考虑将其离线并离散化,普通线段树即可. /** @Date : 2016-12-17-20.49 * @Author : Lweleth ([email protected]) * @Link : https://github.com/ * @Version : */ #include<bi

URAL 1019. Line Painting 线段树 区间合并 离散化

题目来源:URAL 1019. Line Painting 题意:求最长的一段全部为白色的区间 思路:线段树成段更新 区间合并 离散化 这里对应的是一段区间 所以每次不是m+1 而是 l m 和 m r 了 另外我加上了0 和 10^9 这两个点 每一段区间(l, r)我记录的是l和r之间有多少条线段 #include <cstdio> #include <cstring> #include <algorithm> using namespace std; const

hihoCoder #1079 : 离散化 (线段树,数据离散化)

题意:有一块宣传栏,高一定,给出长度,再给出多张海报的张贴位置,问还能见到几张海报(哪怕有一点被看到)?假设海报的高于宣传栏同高. 思路:问题转成“给出x轴上长为L的一条线段,再用n条线段进行覆盖上去,最后还能看到及条线”.长度是0~L,即长度是L,进行离散化的时候,应该用1~L,每个数字表示一个单位长.还有就是按照提示所给的信息实现即可.步骤如下: (1)保存n个数据,做成pair,并将所有出现过的数字在另外找地方排序,去掉重复的,再将数据紧缩化处理,那么大小在1~max.再将紧缩化的数据与原

HUD 1255——覆盖的面积(线段树+面积并多次+离散化)

覆盖的面积 Time Limit: 10000/5000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others) Total Submission(s): 3756    Accepted Submission(s): 1846 Problem Description 给定平面上若干矩形,求出被这些矩形覆盖过至少两次的区域的面积. Input 输入数据的第一行是一个正整数T(1<=T<=100),代表测试数据的数量.每个测试数